/*
 * Copyright (c) 2018 Samsung Electronics Co., Ltd.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

const char cs_cb_proxy_interop[] =
R"__cs_cb(
        internal static partial class Proxy
        {
            //typedef void (*rpc_port_proxy_connected_event_cb)(const char *ep, const char* port_name, rpc_port_h port, void* data);
            [UnmanagedFunctionPointer(CallingConvention.Cdecl)]
            internal delegate void ConnectedEventCallback(string endPoint, string port_name, IntPtr port, IntPtr data);

            //typedef void (*rpc_port_proxy_disconnected_event_cb)(const char *ep, const char* port_name, void* data);
            [UnmanagedFunctionPointer(CallingConvention.Cdecl)]
            internal delegate void DisconnectedEventCallback(string endPoint, string port_name, IntPtr data);

            //typedef void (*rpc_port_proxy_rejected_event_cb) (const char* ep, const char* port_name, void* data);
            [UnmanagedFunctionPointer(CallingConvention.Cdecl)]
            internal delegate void RejectedEventCallback(string endPoint, string port_name, IntPtr data);

            //typedef void (*rpc_port_proxy_received_event_cb) (const char* ep, const char* port_name, void* data);
            [UnmanagedFunctionPointer(CallingConvention.Cdecl)]
            internal delegate void ReceivedEventCallback(string endPoint, string port_name, IntPtr data);

            //int rpc_port_proxy_create(rpc_port_proxy_h *h);
            [DllImport(Libraries.RpcPort, EntryPoint = "rpc_port_proxy_create")]
            internal static extern ErrorCode Create(out IntPtr handle);

            //int rpc_port_proxy_destroy(rpc_port_proxy_h h);
            [DllImport(Libraries.RpcPort, EntryPoint = "rpc_port_proxy_destroy")]
            internal static extern ErrorCode Destroy(IntPtr handle);

            //int rpc_port_proxy_connect(rpc_port_proxy_h h, const char *appid, const char* port);
            [DllImport(Libraries.RpcPort, EntryPoint = "rpc_port_proxy_connect")]
            internal static extern ErrorCode Connect(IntPtr handle, string appId, string port);

            //int rpc_port_proxy_add_connected_event_cb(rpc_port_proxy_h h, rpc_port_proxy_connected_event_cb cb, void* data);
            [DllImport(Libraries.RpcPort, EntryPoint = "rpc_port_proxy_add_connected_event_cb")]
            internal static extern ErrorCode AddConnectedEventCb(IntPtr handle, ConnectedEventCallback cb, IntPtr data);

            //int rpc_port_proxy_add_disconnected_event_cb(rpc_port_proxy_h h, rpc_port_proxy_disconnected_event_cb cb, void* data);
            [DllImport(Libraries.RpcPort, EntryPoint = "rpc_port_proxy_add_disconnected_event_cb")]
            internal static extern ErrorCode AddDisconnectedEventCb(IntPtr handle, DisconnectedEventCallback cb, IntPtr data);

            //int rpc_port_proxy_add_rejected_event_cb(rpc_port_proxy_h h, rpc_port_proxy_rejected_event_cb cb, void* data);
            [DllImport(Libraries.RpcPort, EntryPoint = "rpc_port_proxy_add_rejected_event_cb")]
            internal static extern ErrorCode AddRejectedEventCb(IntPtr handle, RejectedEventCallback cb, IntPtr data);

            //int rpc_port_proxy_add_received_event_cb(rpc_port_proxy_h h, rpc_port_proxy_received_event_cb cb, void* data);
            [DllImport(Libraries.RpcPort, EntryPoint = "rpc_port_proxy_add_received_event_cb")]
            internal static extern ErrorCode AddReceivedEventCb(IntPtr handle, ReceivedEventCallback cb, IntPtr data);
        }
)__cs_cb";
