/*
 * Copyright (c) 2018 Samsung Electronics Co., Ltd.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

const char cs_cb_stub_interop[] =
R"__cs_cb(
        internal static partial class Stub
        {
            //typedef void (*rpc_port_stub_connected_event_cb)(const char *sender, const char *instance, void* data);
            [UnmanagedFunctionPointer(CallingConvention.Cdecl)]
            internal delegate void ConnectedEventCallback(string sender, string instance, IntPtr data);

            //typedef void (* rpc_port_stub_disconnected_event_cb) (const char* sender, const char *instance, void* data);
            [UnmanagedFunctionPointer(CallingConvention.Cdecl)]
            internal delegate void DisconnectedEventCallback(string sender, string instance, IntPtr data);

            //typedef void (* rpc_port_stub_received_event_cb) (const char* sender, const char *instance, rpc_port_h port, void* data);
            [UnmanagedFunctionPointer(CallingConvention.Cdecl)]
            internal delegate int ReceivedEventCallback(string sender, string instance, IntPtr port, IntPtr data);

            //int rpc_port_stub_create(rpc_port_stub_h* h, const char* port_name);
            [DllImport(Libraries.RpcPort, EntryPoint = "rpc_port_stub_create")]
            internal static extern ErrorCode Create(out IntPtr handle, string portName);

            //int rpc_port_stub_destroy(rpc_port_stub_h h);
            [DllImport(Libraries.RpcPort, EntryPoint = "rpc_port_stub_destroy")]
            internal static extern ErrorCode Destroy(IntPtr handle);

            //int rpc_port_stub_listen(rpc_port_stub_h h);
            [DllImport(Libraries.RpcPort, EntryPoint = "rpc_port_stub_listen")]
            internal static extern ErrorCode Listen(IntPtr handle);

            //int rpc_port_stub_add_connected_event_cb(rpc_port_stub_h h, rpc_port_stub_connected_event_cb cb, void* data);
            [DllImport(Libraries.RpcPort, EntryPoint = "rpc_port_stub_add_connected_event_cb")]
            internal static extern ErrorCode AddConnectedEventCb(IntPtr handle, ConnectedEventCallback cb, IntPtr data);

            //int rpc_port_stub_add_disconnected_event_cb(rpc_port_stub_h h, rpc_port_stub_disconnected_event_cb cb, void* data);
            [DllImport(Libraries.RpcPort, EntryPoint = "rpc_port_stub_add_disconnected_event_cb")]
            internal static extern ErrorCode AddDisconnectedEventCb(IntPtr handle, DisconnectedEventCallback cb, IntPtr data);

            //int rpc_port_stub_add_received_event_cb(rpc_port_stub_h h, rpc_port_stub_received_event_cb cb, void* data);
            [DllImport(Libraries.RpcPort, EntryPoint = "rpc_port_stub_add_received_event_cb")]
            internal static extern ErrorCode AddReceivedEventCb(IntPtr handle, ReceivedEventCallback cb, IntPtr data);

            //int rpc_port_stub_add_privilege(rpc_port_stub_h h, const char *privilege);
            [DllImport(Libraries.RpcPort, EntryPoint = "rpc_port_stub_add_privilege")]
            internal static extern ErrorCode AddPrivilege(IntPtr handle, string privilege);

            //int rpc_port_stub_set_trusted(rpc_port_stub_h h, const bool trusted);
            [DllImport(Libraries.RpcPort, EntryPoint = "rpc_port_stub_set_trusted")]
            internal static extern ErrorCode SetTrusted(IntPtr handle, bool trusted);
        }
)__cs_cb";
